/*
QUSOFT MICROSYSTMES
1869

Package: 1869 - Classes related to 1869
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

TString* 	makeString						(TString*, int, ...);
TString* 	mkStr									(TString*, TString*);

TString* mkStr(TString* string, TString* str)
{
	long index;
	TString* strSpr = s("%0");
	TString* stringA;
	TString* stringB;
	TString* stringC;

	index = string->indexOf0(string, strSpr, 0);
	if (index >= 0)
	{
		stringA = string->substring0(string, 0, index - 1);
		stringB = string->substring1(string, index + 2);	
		stringC = stringA->concat(stringA, str);
		string = stringC->concat(stringC, stringB);
	
		stringA->finalize(stringA);
		stringB->finalize(stringB);
		stringC->finalize(stringC);
	
	}
	else
	{
		string = c(string);
	}
	
	strSpr->finalize(strSpr);
	
	return string;
}

TString* makeString(TString* string, int nbStr, ...)
{
	TString *str;
	int i;
	long from = 0;
	long index;
	TString* strSpr = s("%0");
	TString* stringA;
	TString* stringB;
	TString* stringC;
	va_list argptr;
	
	if (nbStr > 10)
	{
		return;
	}
	
	va_start(argptr, nbStr);
	
	for (i = 0; i < nbStr; i++)
	{
		strSpr->string[1] = i + '0';
		str = (TString*)(va_arg(argptr, void*));
		do
		{
			index = string->indexOf0(string, strSpr, from);
			if (index >= 0)
			{
				stringA = string->substring0(string, 0, index - 1);
				stringB = string->substring1(string, index + 2);	
				stringC = stringA->concat(stringA, str);
				string = stringC->concat(stringC, stringB);
			
				stringA->finalize(stringA);
				stringB->finalize(stringB);
				stringC->finalize(stringC);
			
			}
			else
			{
				string = c(string);
			}
		}
		while (index >= 0);
	}
	
	strSpr->finalize(strSpr);
	
	return string;
}

#include "TGood.h"
#include "TItem.h"
#include "TStock.h"
#include "TPort.h"
#include "TBranch.h"
#include "TShip.h"
#include "TPlayer.h"
#include "TGameSetting.h"
#include "TMainMenu.h"
#include "TSystemMenu.h"
#include "TNewGameDialog.h"
#include "TPortInfoDialog.h"
