/*
QUSOFT MICROSYSTMES
1869

Classe: TGameSetting - Type GameSetting

Hirarchie:
TObject -> TGameSetting
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * The TGameSetting class represents a 1869's game setting.
*/

//Structure de l'objet de Type GameSetting extension de TObject
typedef struct GameSetting {
	char *class; //Le nom de la classe
	char *super; //Le nom de la superclasse
	struct Object* 	(*clone) 		(struct Object*);
	BOOL 						(*equals) 	(struct Object*, struct Object*);
	void 						(*finalize) (struct Object*);
	TString* 				(*toString) (struct Object*);
	int length;
	float startingMoney;
} TGameSetting;

//Dclaration des constructeurs
TGameSetting* TGameSetting0(int, float);

//Dclaration des mthodes


/**
 * Ce constructeur instancie un objet de Type GameSetting.
 @since Release 1.0
*/
TGameSetting* TGameSetting0 (int length, float startingMoney) {
	TGameSetting *this = (TGameSetting*)malloc(sizeof(TGameSetting));
	
	this->class  = "TGameSetting";
	this->super  = "TObject";
	
	this->clone    = TObject_clone;
	this->equals   = TObject_equals;
	this->finalize = TObject_finalize;
	this->toString = TObject_toString;
	
	this->length				= length;
	this->startingMoney = startingMoney;
	
	return this;
}
