/*
QUSOFT MICROSYSTMES
1869

Classe: TNewGameDialog - Type NewGameDialog

Hirarchie:
TObject -> TComponent -> TContainer -> TFrame -> TNewGameDialog
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * TNewGameDialog class represents the dialog shown to setup a new game.
*/

//Structure de l'objet de Type NewGameDialog extension de TFrame
typedef struct NewGameDialog  {
	char *class; 	//Le nom de la classe
	char *super; 	//Le nom de la superclasse
	struct Frame*	(*clone)		(struct Frame*);
	BOOL					(*equals)		(struct Frame*, struct Object*);
	void					(*finalize)	(struct NewGameDialog*);
	TString* 			(*toString) (struct Frame*);
	int height;  	//La hauteur du composant
	BITMAP *img;	//L'image de la partie de l'cran cache par le composant
	BOOL visible; //La visibilit du composant
	int width;		//La largeur du composant
	int x;				//La position horizontale du composant
	int y;				//La position verticale du composant
	void							(*move)				(struct Component*, int, int);
	void							(*print)		 	(struct Frame*);
	void							(*setBounds)	(struct Container*, int, int, int, int);
	void							(*setHeight)	(struct Component*, int);
	void							(*setVisible)	(struct Container*, BOOL);
	void							(*setWidth)		(struct Component*, int);
	void							(*setX)				(struct Component*, int);
	void							(*setY)				(struct Component*, int);
	TVector* contentPane;	//Le contenu du Container
	BOOL* visibility;			//La visibilit des composants
	void							(*bringOn)		(struct Container*, TComponent*);
	void							(*center)			(struct Container*, TComponent*);
	void							(*drag)				(struct Container*, TComponent*, TCursor*);
	TString* title;				//Le titre de la fentre
	void							(*setTitle)		(struct Frame*, TString*);
	void							(*add)				(struct Container*, TComponent*);
	TString *str0;
	TString *str01;
	TString *str02;
	TString *str03;
	TString *str04;
	TString *str11;
	TString *str12;
	TString *str13;
	TString *str14;
	TString *str15;
	TString *str16;
	TLabel *lblPlayers;
	TLabel *lblLong;
	TButton *btnOk;
	TComboBox *cbPlayers;
	TComboBox *cbLong;
	TString *str41;
	TString *str42;
	TLabel *lblNoPlayer;
	TLabel *lblPort;
	TComboBox *cbPort;
	TLabel *lblName;
	TTextField *txtName;
	TComboBox *cbSex;
	TLabel *lblComp;
	TTextField *txtComp;
	TTextArea *txtQuote;
	TGarbageCollector* gc;
} TNewGameDialog ;

//Dclaration des constructeurs
TNewGameDialog* TNewGameDialog0(TCursor*, TPort**);

//Dclaration des mthodes
void 	TNewGameDialog_finalize		(TNewGameDialog*);

/**
 * Ce constructeur instancie un objet de Type NewGameDialog.
 @since Release 1.0
*/
TNewGameDialog* TNewGameDialog0 (TCursor* cr, TPort** ports) {
	TNewGameDialog *this = (TNewGameDialog*)malloc(sizeof(TNewGameDialog));
	
	int i;
	
	this->class  = "TNewGameDialog";
	this->super  = "TFrame";
	
	this->height 			= 100;
	this->visible 		= FALSE;
	this->width 			= 231;
	this->x						= 0;
	this->y						= 0;
	this->img					= (BITMAP*)malloc(sizeof(BITMAP));
	this->contentPane = TVector0();
	this->visibility	= NULL;
	this->title				= s("New Game");
	
	this->clone 	 = TFrame_clone;
	this->equals 	 = TFrame_equals;
	this->finalize = TNewGameDialog_finalize;
	this->toString = TFrame_toString;
	
	this->move 			 = TComponent_move;
	this->print 		 = TFrame_print;
	this->setBounds  = TContainer_setBounds;
	this->setHeight  = TComponent_setHeight;
	this->setVisible = TContainer_setVisible;
	this->setWidth 	 = TComponent_setWidth;
	this->setX 			 = TComponent_setX;
	this->setY 			 = TComponent_setY;
	
	this->bringOn		 = TContainer_bringOn;
	this->center		 = TContainer_center;
	this->drag			 = TContainer_drag;
	this->add				 = TContainer_add;

	this->setTitle	 = TFrame_setTitle;
	
	this->gc				 = TGarbageCollector0();
	
	this->str0	= s("");
	this->gc->add(this->gc, this->str0);
	this->str01 = s("1");
	this->gc->add(this->gc, this->str01);
	this->str02 = s("2");
	this->gc->add(this->gc, this->str02);
	this->str03 = s("3");
	this->gc->add(this->gc, this->str03);
	this->str04 = s("4");
	this->gc->add(this->gc, this->str04);
	this->str11 = s("5 years");
	this->gc->add(this->gc, this->str11);
	this->str12 = s("10 years");
	this->gc->add(this->gc, this->str12);
	this->str13 = s("15 years");
	this->gc->add(this->gc, this->str13);
	this->str14 = s("20 years");
	this->gc->add(this->gc, this->str14);
	this->str15 = s("26 years");
	this->gc->add(this->gc, this->str15);
	this->str16 = s("5 years \"starting player\"");
	this->gc->add(this->gc, this->str16);
	this->lblPlayers 	= TLabel2("How many players?");
	this->gc->add(this->gc, this->lblPlayers);
	this->lblLong		 	= TLabel2("How long do you want to play?");
	this->gc->add(this->gc, this->lblLong);
	this->btnOk 		 	= TButton2("Ok");
	this->gc->add(this->gc, this->btnOk);
	this->cbPlayers 	= TComboBox0();
	this->gc->add(this->gc, this->cbPlayers);
	this->cbLong 	 	 	= TComboBox0();
	this->gc->add(this->gc, this->cbLong);
	this->str41 			= s("Male  ");
	this->gc->add(this->gc, this->str41);
	this->str42 			= s("Female");
	this->gc->add(this->gc, this->str42);
	this->lblNoPlayer	= TLabel0();
	this->gc->add(this->gc, this->lblNoPlayer);
	this->lblPort			= TLabel2("In which port would you like to start?");
	this->gc->add(this->gc, this->lblPort);
	this->cbPort		 	= TComboBox0();
	this->gc->add(this->gc, this->cbPort);
	this->lblName			= TLabel2("Name: ");
	this->gc->add(this->gc, this->lblName);
	this->txtName		 	= TTextField2("          ");
	this->gc->add(this->gc, this->txtName);
	this->cbSex			 	= TComboBox0();
	this->gc->add(this->gc, this->cbSex);
	this->lblComp			= TLabel2("Company Name: ");
	this->gc->add(this->gc, this->lblComp);
	this->txtComp		 	= TTextField2("               ");
	this->gc->add(this->gc, this->txtComp);
	this->txtQuote		= TTextArea2("Each person must form his own conception of the past. Noone is satisfied with the accomplishments of the others who have gone before them, even if they were experts.   History always has two components: that which took      place and the person who views it from a perspective in time and seeks to understands it.  -Golo Mann");
	this->gc->add(this->gc, this->txtQuote);
	
	//this->setBounds(this, 0, 0, 231, 100);
	
	this->lblLong->move(this->lblLong, 1, 15);
	this->add(this, this->lblLong);

	this->cbLong->move(this->cbLong, 2, 26);
	this->cbLong->setWidth(this->cbLong, 170);
	this->cbLong->items->addElement(this->cbLong->items, this->str11);
	this->cbLong->items->addElement(this->cbLong->items, this->str12);
	this->cbLong->items->addElement(this->cbLong->items, this->str13);
	this->cbLong->items->addElement(this->cbLong->items, this->str14);
	this->cbLong->items->addElement(this->cbLong->items, this->str15);
	this->cbLong->items->addElement(this->cbLong->items, this->str16);
	this->cbLong->selected = this->str11;
	this->cbLong->cursor = cr;
	this->add(this, this->cbLong);

	this->lblPlayers->move(this->lblPlayers, 1, 42);
	this->add(this, this->lblPlayers);

	this->cbPlayers->move(this->cbPlayers, 2, 57);
	this->cbPlayers->items->addElement(this->cbPlayers->items, this->str01);
	this->cbPlayers->items->addElement(this->cbPlayers->items, this->str02);
	this->cbPlayers->items->addElement(this->cbPlayers->items, this->str03);
	this->cbPlayers->items->addElement(this->cbPlayers->items, this->str04);
	this->cbPlayers->selected = this->str01;
	this->cbPlayers->cursor = cr;
	this->add(this, this->cbPlayers);

	this->center(this, this->btnOk);
	this->btnOk->move(this->btnOk, this->btnOk->x, 80);
	this->add(this, this->btnOk);

	this->lblNoPlayer->move(this->lblNoPlayer, 50, 0);
	this->add(this, this->lblNoPlayer);
		
	this->lblPort->move(this->lblPort, 1, 15);
	this->add(this, this->lblPort);
		
	this->cbPort->move(this->cbPort, 2, 26);
	this->cbPort->setWidth(this->cbPort, 150);
	this->cbPort->items->addElement(this->cbPort->items, ports[0]);
	this->cbPort->items->addElement(this->cbPort->items, ports[1]);
	this->cbPort->items->addElement(this->cbPort->items, ports[2]);
	this->cbPort->items->addElement(this->cbPort->items, ports[3]);
	this->cbPort->items->addElement(this->cbPort->items, ports[4]);
	this->cbPort->cursor = cr;
	this->add(this, this->cbPort);

	this->lblName->move(this->lblName, 1, 43);
	this->add(this, this->lblName);
		
	this->txtName->move(this->txtName, this->lblName->x + this->lblName->width, 43);
	this->add(this, this->txtName);
		
	this->cbSex->move(this->cbSex, this->txtName->x + this->txtName->width + 4, 43);
	this->cbSex->items->addElement(this->cbSex->items, this->str41);
	this->cbSex->items->addElement(this->cbSex->items, this->str42);
	this->cbSex->cursor = cr;
	this->add(this, this->cbSex);
		
	this->lblComp->move(this->lblComp, 1, 60);
	this->add(this, this->lblComp);
	
	this->txtComp->move(this->txtComp, this->lblComp->x + this->lblComp->width, 60);
	this->add(this, this->txtComp);
	
	this->txtQuote->setBounds(this->txtQuote, 1, 15, 229, 98);
	this->add(this, this->txtQuote);

	return this;
}

void TNewGameDialog_finalize (TNewGameDialog* this)
{
	this->setVisible(this, FALSE);
	
	TRY {
		this->contentPane->finalize(this->contentPane);
		this->gc->finalize(this->gc);
		if (this->visibility != NULL) {
			free(this->visibility);
		}
		this->title->finalize(this->title);
		free(this->img);
		free(this);
	}
	ONERR {}
	ENDTRY
}

