/*
QUSOFT MICROSYSTMES
1869

Classe: TPlayer - Type Player

Hirarchie:
TObject -> TPlayer
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * The TPlayer class represents a 1869's player.
*/

//Structure de l'objet de Type Player extension de TObject
typedef struct Player {
	char *class; //Le nom de la classe
	char *super; //Le nom de la superclasse
	struct Object* 	(*clone) 		(struct Object*);
	BOOL 						(*equals) 	(struct Object*, struct Object*);
	void 						(*finalize) (struct Player*);
	TString* 				(*toString) (struct Object*);
	TString* name;
	char sex;
	TString* company;
	TPort* startPort;
	TVector* branches;
	TVector* ships;
} TPlayer;

//Dclaration des constructeurs
TPlayer* TPlayer0(TString*, TString*, char);

//Dclaration des mthodes
void TPlayer_finalize	(TPlayer*);

/**
 * Ce constructeur instancie un objet de Type Player.
 @since Release 1.0
*/
TPlayer* TPlayer0 (TString* name, TString* company, char sex) {
	TPlayer *this = (TPlayer*)malloc(sizeof(TPlayer));
	
	this->class  = "TPlayer";
	this->super  = "TObject";
	
	this->clone    = TObject_clone;
	this->equals   = TObject_equals;
	this->finalize = TPlayer_finalize;
	this->toString = TObject_toString;
	
	this->name 			= c(name);
	this->sex	 			= sex;
	this->company 	= c(company);
	this->startPort = NULL;
	this->branches 	= TVector0();
	this->ships 		= TVector0();
	
	return this;
}

void TPlayer_finalize	(TPlayer* this) {
	
	int i;
	TObject *obj;
	this->name->finalize(this->name);
	this->company->finalize(this->company);
	
	for (i = 0; i < this->branches->size; i++)
	{
		obj = (TObject*)this->branches->elementAt(this->branches, i);
		obj->finalize(obj);
	}
	
	this->branches->finalize(this->branches);
	
	for (i = 0; i < this->ships->size; i++)
	{
		obj = (TObject*)this->ships->elementAt(this->ships, i);
		obj->finalize(obj);
	}
	
	this->ships->finalize(this->ships);
	
	free(this);
}
