/*
QUSOFT MICROSYSTMES
1869

Classe: TPortInfoDialog - Type PortInfoDialog

Hirarchie:
TObject -> TComponent -> TContainer -> TFrame -> TPortInfoDialog
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * TPortInfoDialog class represents the dialog displayed to get information about a port.
*/

//Structure de l'objet de Type PortInfoDialog  extension de TFrame
typedef struct PortInfoDialog  {
	char *class; 	//Le nom de la classe
	char *super; 	//Le nom de la superclasse
	struct Frame*	(*clone)		(struct Frame*);
	BOOL					(*equals)		(struct Frame*, struct Object*);
	void					(*finalize)	(struct PortInfoDialog*);
	TString* 			(*toString) (struct Frame*);
	int height;  	//La hauteur du composant
	BITMAP *img;	//L'image de la partie de l'cran cache par le composant
	BOOL visible; //La visibilit du composant
	int width;		//La largeur du composant
	int x;				//La position horizontale du composant
	int y;				//La position verticale du composant
	void							(*move)				(struct Component*, int, int);
	void							(*print)		 	(struct Frame*);
	void							(*setBounds)	(struct Container*, int, int, int, int);
	void							(*setHeight)	(struct Component*, int);
	void							(*setVisible)	(struct Container*, BOOL);
	void							(*setWidth)		(struct Component*, int);
	void							(*setX)				(struct Component*, int);
	void							(*setY)				(struct Component*, int);
	TVector* contentPane;	//Le contenu du Container
	BOOL* visibility;			//La visibilit des composants
	void							(*bringOn)		(struct Container*, TComponent*);
	void							(*center)			(struct Container*, TComponent*);
	void							(*drag)				(struct Container*, TComponent*, TCursor*);
	TString* title;				//Le titre de la fentre
	void							(*setTitle)		(struct Frame*, TString*);
	void							(*add)				(struct Container*, TComponent*);
	TString* politicStrings[5];
	TString* strImage;
	TString* strTitle;
	TString* strCountry;
	TString* strExport;
	TString* strPolitic;
	TLabel* lblCountry;
	TLabel* lblExport;
	TLabel* lblPolitic;
	TImage* image;
	TGarbageCollector* gc;
	TPort** ports;
	void							(*showPort)		(struct PortInfoDialog*, int);
} TPortInfoDialog ;

//Dclaration des constructeurs
TPortInfoDialog* TPortInfoDialog0(TPort**);

//Dclaration des mthodes
void	TPortInfoDialog_showPort		(TPortInfoDialog*, int);
void 	TPortInfoDialog_finalize		(TPortInfoDialog*);

/**
 * Ce constructeur instancie un objet de Type PortInfoDialog.
 @since Release 1.0
*/
TPortInfoDialog* TPortInfoDialog0 (TPort** ports) {
	TPortInfoDialog *this = (TPortInfoDialog*)malloc(sizeof(TPortInfoDialog));
	
	int i;
	
	this->class  = "TPortInfoDialog";
	this->super  = "TFrame";
	
	this->height 			= 80;
	this->visible 		= FALSE;
	this->width 			= 240;
	this->x						= 0;
	this->y						= 0;
	this->img					= (BITMAP*)malloc(sizeof(BITMAP));
	this->contentPane = TVector0();
	this->visibility	= NULL;
	this->title				= s("");
	
	this->clone 	 = TFrame_clone;
	this->equals 	 = TFrame_equals;
	this->finalize = TPortInfoDialog_finalize;
	this->toString = TFrame_toString;
	
	this->move 			 = TComponent_move;
	this->print 		 = TFrame_print;
	this->setBounds  = TContainer_setBounds;
	this->setHeight  = TComponent_setHeight;
	this->setVisible = TContainer_setVisible;
	this->setWidth 	 = TComponent_setWidth;
	this->setX 			 = TComponent_setX;
	this->setY 			 = TComponent_setY;
	
	this->bringOn		 = TContainer_bringOn;
	this->center		 = TContainer_center;
	this->drag			 = TContainer_drag;
	this->add				 = TContainer_add;

	this->setTitle	 = TFrame_setTitle;

	this->showPort	 = TPortInfoDialog_showPort;
	
	this->gc				 = TGarbageCollector0();
	
	this->lblCountry = TLabel0();
	this->lblCountry->move(this->lblCountry, 96, 15);
	this->add(this, this->lblCountry);
	this->gc->add(this->gc, this->lblCountry);
	this->lblExport  = TLabel0();
	this->add(this, this->lblExport);
	this->gc->add(this->gc, this->lblExport);
	this->lblExport->move(this->lblExport, 96, 30);
	this->lblPolitic = TLabel0();
	this->add(this, this->lblPolitic);
	this->gc->add(this->gc, this->lblPolitic);
	this->lblPolitic->move(this->lblPolitic, 96, 45);
	this->image 		 = TImage0();
	this->image->move(this->image, 2, 15);
	this->add(this, this->image);
	this->gc->add(this->gc, this->image);
	
	this->politicStrings[0] = s("stable");
	this->politicStrings[1] = s("unrest");
	this->politicStrings[2] = s("revolts");
	this->politicStrings[3] = s("civil war");
	this->politicStrings[4] = s("WAR");
	
	for (i = 0; i < 5; i++)
	{
		this->gc->add(this->gc, this->politicStrings[i]);
	}
	
	this->strImage = s("port%0");
	this->gc->add(this->gc, this->strImage);
	this->strTitle = s("Port: %0");
	this->gc->add(this->gc, this->strTitle);
	this->strCountry = s("Country: %0");
	this->gc->add(this->gc, this->strCountry);
	this->strExport  = s("Major export: %0");
	this->gc->add(this->gc, this->strExport);
	this->strPolitic = s("Pol. state: %0");
	this->gc->add(this->gc, this->strPolitic);
	
	this->ports = ports;
	
	return this;
}

void TPortInfoDialog_finalize (TPortInfoDialog* this)
{
	this->setVisible(this, FALSE);
	
	TRY {
		this->contentPane->finalize(this->contentPane);
		this->gc->finalize(this->gc);
		if (this->visibility != NULL) {
			free(this->visibility);
		}
		this->title->finalize(this->title);
		free(this->img);
		free(this);
	}
	ONERR {}
	ENDTRY
}

void TPortInfoDialog_showPort(TPortInfoDialog* this, int i)
{
	TString *strNo = Integer_toString(i);
	TString *strImage = mkStr(this->strImage, strNo);
	TString *strTitle = mkStr(this->strTitle, this->ports[i]->name);
	TString *strCountry = mkStr(this->strCountry, this->ports[i]->country);
	TString *strExport = mkStr(this->strExport, s("broche"));
	TString *strPolitic = mkStr(this->strPolitic, this->politicStrings[this->ports[i]->politic]);

	this->image->loadVAR(this->image, strImage, 94, 61);
	this->setTitle(this, strTitle);
	this->lblCountry->setCaption(this->lblCountry, strCountry);
	this->lblExport->setCaption(this->lblExport, strExport);
	this->lblPolitic->setCaption(this->lblPolitic, strPolitic);

	strNo->finalize(strNo);
	strImage->finalize(strImage);
	strTitle->finalize(strTitle);
	strCountry->finalize(strCountry);
	strExport->finalize(strExport);
	strPolitic->finalize(strPolitic);

	this->setVisible(this, TRUE);
	this->image->setVisible(this->image, TRUE);
	this->lblCountry->setVisible(this->lblCountry, TRUE);
	this->lblExport->setVisible(this->lblExport, TRUE);
	this->lblPolitic->setVisible(this->lblPolitic, TRUE);
	
	ngetchx();

	this->setVisible(this, FALSE);
}
